const { app: appConfig } = require('./config')
const KoaAPP = require('koa')
const { router } = require('./router')
const koaLogger = require('koa-logger')
const logger = require('./sgs_loggger')
const { common, parseParams } = require('./middleware')

const app = new KoaAPP()

app.proxy = true

app.use(common)
app.use(koaLogger())
app.use(parseParams)
app.use(router.routes())
app.use(router.allowedMethods())

app.listen(appConfig.port)

// 捕捉遗漏的异常，防止程序退出
process.on('uncaughtException', (e) => {
  process.exit(1)
})

process.on('warning', (warning) => {
  logger.error(warning.name)
  logger.error(warning.message)
  logger.error(warning.stack)
})

/*
process.on('SIGINT',()=>{
    //
    process.exit(1)
}) */
