const root = process.cwd()
const { resolve, join } = require('path')
process.env.NODE_ENV = process.env.NODE_ENV || 'development'
const { NODE_ENV } = process.env
const [isDevelopment, isProduction] = [
  NODE_ENV === 'development',
  NODE_ENV === 'production'
]

// 需要打包的文件夹
const frontRoot = resolve(root, '../sgs-front')
const port = process.env.PORT || 8417

const host = 'localhost'
const url = `${host}:${port}`

const config = {
  path: {
    root: root,
    mock: resolve(root, 'mock'),

    src: resolve(frontRoot, 'src'),
    pages: resolve(frontRoot, 'src/pages'),
    global: resolve(frontRoot, 'src/global.js'),

    temp: resolve(root, '.temp'),
    dll: resolve(root, '.temp/dll'),
    dllVersion: resolve(root, '.temp/dll/version.json'),
    webpack: resolve(root, 'webpack'),
    template: resolve(root, 'template'),
    templateSSR: resolve(root, 'webpack/template.ssr.ejs'),
    prepackPath: resolve(root, '.temp/prepack'),
    static: resolve(root, 'static'),
    nodeModule: resolve(root, 'node_modules'),
    dist: resolve(root, 'dist'),
    zoo: resolve(root, 'zoo'),

    favicon: resolve(root, 'favicon.ico')
  },
  server: {
    host,
    port,
    NODE_ENV,
    isDevelopment,
    isProduction,
    url
  },
  project: {
    name: 'sogou', // project name
    title: 'Sogou Test', // 项目标题
    index: 'index',
    html: 'detail' // html前缀
  },
  webpack: {
    dllEntry: []
  }
}

module.exports = config
