const { feedDetail: feedDetailConfig } = require('config').get('data')

function redisConfig () {
  return process.env.NODE_ENV === 'production'
    ? {
      fe_cache: {
        host: 'a.redis.sogou',
        port: '2017',
        password: 'SgsDevFeCache',
        db: 1
      }
    }
    : {
      fe_cache: {
        host: '10.134.109.184',
        port: '6379',
        password: 'sgsdevfe',
        db: 1
      }
    }
}

function feedDetailSetting () {
  return process.env.NODE_ENV === 'production'
    ? [
      {
        host: 'weball01.sgsfe.djt.ted',
        port: 8088
      },
      {
        host: 'weball02.sgsfe.djt.ted',
        port: 8088
      },
      {
        host: 'weball01.sgsfe.sjs.ted',
        port: 8088
      },
      {
        host: 'weball02.sgsfe.sjs.ted',
        port: 8088
      }
    ]
    : [
      {
        host: '10.129.233.66',
        port: 8088
      }
    ]
}

// monica is the private key of aes
const config = {
  app: {
    redisCache: process.env.NODE_ENV === 'production',
    feed_detail_path: '/weball/api/proxy/resource/article/feedDetail',
    top_article_advertise_path: '/weball/api/proxy/top/article/advertise',
    kv_limit: 5,
    kv_timeout: 300,
    kv_keepalive_timeout: 4000,
    kv_charset: 'utf8',
    monica: 'sougouappno.0001',
    adQueryStatement: 'select * from wx_channel where stdpid = ?',
    mid: '966b@@shida_yinhe',
    xid: '6329@@shida_yinhe',
    retryTimes: 3,
    port: 8000
  },
  redis: redisConfig(),
  mysql: {
    host: 'admin.weixinheadline.rds.sogou',
    port: 3306,
    user: 'wx_mis',
    passwd: 'wx_mis_headline',
    db: 'wx',
    charset: 'UTF8_GENERAL_CI',
    maxConnection: 5
  }
}

if (Array.isArray(feedDetailConfig) && feedDetailConfig.length) {
  config.feed_detail = feedDetailConfig
} else {
  config.feed_detail = feedDetailSetting()
}

module.exports = config
