/**
 * Created by hinotohui on 18/11/28.
 */
const fs = require('fs')
const { ResponseError } = require('../error')
const cwd = process.cwd()

function read (encoding) {
  return function (path) {
    return fs.readFileSync(path, encoding)
  }
}

const config = {
  'js': [read('utf8'), 'text/javascript'],
  'css': [read('utf8'), 'text/css'],
  'png': [read(), 'image/png'],
  'jpg': [read(), 'image/jpg']
}

exports.control = async function (ctx) {
  if (fs.existsSync(cwd + ctx.path)) {
    let match = ctx.path.match(/.*\.(.+)/)
    if (match) {
      let suffix = match[1]

      if (config[suffix]) {
        ctx.set('Cache-Control', 'max-age=31536000')
        ctx.body = config[suffix][0](cwd + ctx.path)
        ctx.type = config[suffix][1]

        return
      }
    }
  }

  throw new ResponseError({ code: 404, message: 'asset not exist' })
}
