const { ResponseError } = require('../error')
const request = require('request')
const { feed_detail: webAllConfig } = require('../config')

exports.control = async function (ctx) {
  let url

  if (ctx.url.indexOf('weball') != -1) {
    url = 'http://' + webAllConfig[0].host + ':' + webAllConfig[0].port + ctx.url
  } else if (ctx.url.indexOf('sgsearch') != -1) {
    url = 'http://sa.sogou.com' + ctx.url
  }

  if (!url) { return }

  ctx.body = await new Promise((resolve) => {
    request(url, {
      headers: {
        'User-Agent': 'Mozilla/5.0 (Linux; Android 6.0; Nexus 5 Build/MRA58N) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/70.0.3538.102 Mobile Safari/537.36'
      }
    }, function (err, html) {
      if (!err) { resolve(html.body) } else {
        throw new ResponseError({ code: 404, message: 'weball proxy error' })
      }
    })
  })
}
