
const { app: appConfig } = require('../config')
const logger = require('../sgs_loggger')
const uuidv1 = require('uuid/v1')

async function common (ctx, next) {
  try {
    await next()
  } catch (e) {
    // 处理404或500
    logger.error(e)

    e.code = e.code || 500
    e.message = e.message || ''

    switch (e.code) {
      case 404:
        break
      case 500:
        break
      default:
    }
  }
}

async function parseParams (ctx, next) {
  ctx.realip = ctx.request.headers['x-real-ip'] || (ctx.ips.length > 0 ? ctx.ips[ctx.ips.length - 1] : ctx.ip) || ''
  ctx.queryParams = ctx.request.query
  await next()
}

async function uuid (ctx, next) {
  ctx.uuid = uuidv1()
  await next()
}

module.exports = {
  parseParams,
  common,
  uuid
}
