/**
 * Created by hinotohui on 18/11/19.
 */
const { mysql: mysqlConfig } = require('../config')
const mysql = require('mysql')
const logger = require('../sgs_loggger')
const { circuitBreaker } = require('../backend/circuitBreaker')

let pool = mysql.createPool({
  'host': mysqlConfig.host,
  'port': mysqlConfig.port,
  'user': mysqlConfig.user,
  'password': mysqlConfig.passwd,
  'database': mysqlConfig.db,
  'charset': mysqlConfig.charset,
  'limit': mysqlConfig.maxConnection
})

async function getResult (key, sql) {
  try {
    return await circuitBreaker(200, new Promise((resolve, reject) => {
      if (!key) {
        resolve(null)
      } else {
        pool.getConnection((err, conn) => {
          if (err) {
            logger.error(err)
            resolve(null)
          } else {
            conn.query({
              sql: sql,
              values: key
            }, (err, results, field) => {
              if (err) {
                logger.error(err)
                conn.destroy()
                resolve(null)
              } else {
                conn.release()
                resolve(results)
              }
            })
          }
        })
      }
    }))
  } catch (e) {
    return null
  }
}

process.on('exit', () => {
  pool.end()
})

module.exports = {
  getResult
}
