const send = require('koa-send')
const path = require('path')
const fse = require('fs-extra')
const pathConfig = require('config').get('path')

const { publicPath } = require('./../../webpack/output.js')

module.exports = () => {
  return async (ctx, next) => {
    let prefix = publicPath
    let maxage = 365 * 24 * 60 * 60 * 1000 // one year
    let reqPath = ctx.path

    // vendor
    let realReqPath
    
    realReqPath = reqPath.substring(prefix.length - 1)

    let filePath = path.resolve(pathConfig.static, `.${realReqPath}`)
    const exists = await fse.pathExists(filePath)

    let result
    if (exists) {
      result = await send(ctx, realReqPath, {
        root: pathConfig.static,
        maxage,
        setHeaders: (res, path, stats) => {
          res.setHeader('Author', 'xiaows')
          if (path.endsWith('.json')) {
            res.setHeader('Access-Control-Allow-Origin', '*')
          }
          res.setHeader(
              'Cache-Control',
              `max-age=${
                  path.endsWith('.html') ? 0 : 3.1536 * 1e10
              },must-revalidate`
          );
          res.setHeader('Cache-Control', `max-age=0,must-revalidate`)
        }
      })
    }

    if (!result) {
      ctx.status = 404
      ctx.body = `404 | Page Not Found | ${ctx.path}`
    }
  }
}
