const pathConfig = require('config').get('path')
const projectConfig = require('config').get('project')
const fs = require('fs')
const path = require('path')

module.exports = function () {
  return async (ctx, next) => {
    let reqPath = ctx.path
    if (!reqPath.startsWith(`/${projectConfig.name}/${projectConfig.html}`)) {
      return await next()
    }
    let [project, html, folder, component] = reqPath.split('/').filter(v => v)
    let filePath = path.join(pathConfig.mock, `input/${folder}.js`)
    let isExists = fs.existsSync(filePath)

    if (!isExists) {
      console.log(`[Mock Input]: No argument at input on ${reqPath}`)
      return await next()
    }

    delete require.cache[filePath]
    let methods = require(filePath)
    let api

    if (component === '' || component === undefined) {
      component = '/'
    }

    if ((api = methods[component]) && api.mock) {
      ctx.query = api.query || ctx.query
      ctx.request.body = api.body || ctx.request.body
      console.log(`[Mock Input]: Have Argument at Input`)
    } else {
      console.log(`[Mock Input]: No argument at input on ${reqPath}`)
    }

    await next()
  }
}
