/**
 * Router [ discard ]
 *
 * @author xiaows
 * @description
 *  通过 url param 调用 controller 获取相关数据
 * @feature
 *  创建钩子，避免频繁上线
 */

const { control } = require('../../controller/sgsNewsContoller.js')
const pathToRegexp = require('path-to-regexp')
const projectConfig = require('config').get('project')
let { name, html } = projectConfig

module.exports = (app, config) => {
  return async (ctx, next) => {
    let router = `/${name}/${html}/:product_type/:user_type`
    let reqPath = ctx.path
    let re = pathToRegexp(router)
    let result
    if (!(result = re.exec(reqPath))) {
      return await next()
    }

    let params = router
      .split('/')
      .filter(v => {
        return v.startsWith(':')
      })
      .map(v => {
        return v.substring(1)
      })
      .reduce((prev, cur, index) => {
        prev[cur] = result[index + 1]

        return prev
      }, {})

    ctx.params = params

    await control(ctx, async () => {})

    ctx.__SSR_CONTENT__ = {
      result: ctx.result || '',
      ad: ctx.adResult || '',
      control: ctx.control,
      _msg_: 'success'
    }

    return await next()
  }
}
