const pathConfig = require('config').get('path')
const glob = require('glob')
const path = require('path')
const { publicPath } = require('../../webpack/output.js')

function createHeaderScriptPath(headerScriptNames) {
  const outputJsStaticPath = glob.sync(
    path.resolve(pathConfig.static, './js/**')
  )
  const headerScriptPath =
    headerScriptNames
      .map(v => {
        return outputJsStaticPath.find(k => {
          let filename = path.basename(k)
          return filename.startsWith(v)
        })
      })
      .filter(v => v)
      .map(v => {
        return `<script src="${publicPath}js/${path.basename(v)}"></script>`
      })
      .join('\n') || ''

  return headerScriptPath
}

module.exports = createHeaderScriptPath
