const glob = require('glob')
const globalConfig = require('config')
const pathConfig = globalConfig.get('path')
const webpackConfig = globalConfig.get('webpack') || {}
const { resolve, basename } = require('path')
const { statSync } = require('fs')

let customAlias = (webpackConfig && webpackConfig.alias) || {}

const alias = glob
  .sync(resolve(pathConfig.src, './*'))
  .filter(v => {
    return statSync(v).isDirectory()
  })
  .reduce((prev, cur) => {
    prev[basename(cur)] = cur
    return prev
  }, {})

Object.assign(alias, customAlias)

module.exports = { alias }
