const path = require('path')
const glob = require('glob')
const fs = require('fs')
const fse = require('fs-extra')
const mkdirp = require('mkdirp')
const MODE_0755 = parseInt('0755', 8)

const {
  pathConfig: { template: tempatePath }
} = require('./config.js')

function mkdir (base, dir) {
  var loc = path.join(base, dir)

  console.log('   \x1b[36mcreate\x1b[0m : ' + loc + path.sep)
  mkdirp.sync(loc, MODE_0755)
}

function createApp (name, dir) {
  if (dir !== '.') {
    mkdir(dir, '.')
  }

  glob
    .sync(tempatePath + '/app/**')
    .filter(v => {
      let stat = fs.statSync(v)
      return !stat.isDirectory()
    })
    .forEach(v => {
      let filepath = v.slice((tempatePath + '/app').length)
      let targetfile = path.join(dir, filepath)
      fse.ensureFileSync(targetfile)
      fse.copyFileSync(v, targetfile)
    })

  console.log('[Create App]: Success, 愉快的Coding吧！！！')
}

module.exports = createApp
