process.env.NODE_ENV = process.env.NODE_ENV || 'development'
const root = process.cwd()
const { resolve } = require('path')
const { NODE_ENV } = process.env
const [isDevelopment, isProduction] = [
  NODE_ENV === 'development',
  NODE_ENV === 'production'
]

const host = 'localhost'
const port = process.env.PORT || 8417
const url = `${host}:${port}`

module.exports = {
  path: {
    root: root,
    mock: resolve(root, 'mock'),
    src: resolve(root, 'src'),
    pages: resolve(root, 'src/pages'),
    global: resolve(root, 'src/global.js'),
    globalServer: resolve(root, 'src/global-server.js'),
    temp: resolve(root, '.temp'),
    dll: resolve(root, '.temp/dll'),
    dllVersion: resolve(root, '.temp/dll/version.json'),
    webpack: resolve(root, 'webpack'),
    template: resolve(root, 'template'),
    templateSSR: resolve(root, 'webpack/template.ssr.ejs'),
    prepackPath: resolve(root, '.temp/prepack'),
    dist: resolve(root, 'dist'),
    static: resolve(root, 'static'),
    nodeModule: resolve(root, 'node_modules'),
    favicon: resolve(root, 'favicon.ico'),
    zoo: resolve(root, 'zoo')
  },
  server: {
    NODE_ENV,
    isDevelopment,
    isProduction,
    host,
    port,
    url
  },
  project: {
    name: 'sogou', // project name
    title: 'Sogou Test', // 项目标题
    index: 'index',
    html: 'detail' // html前缀
  },
  proxy: {
    weball: 'http://sa.sogou.com/'
  }
}
